function test_mexCASD_SR(ImgNo)
addpath(genpath('./'));

if nargin <  1
    ImgNo = 1;
end

Input_dir = 'TestImages/';
Output_dir = 'Results/';
img_dir = dir(fullfile(Input_dir,'*.png'));

img_num = length(img_dir);

pSize = 9;
model_params.patch_size = pSize;
model_params.scale = 3;
model_params.msgprt = 1;

filewriting = false;
filename = sprintf('Results/mexCASD-%s %d%d%.0f.txt',date,hour(now),minute(now),second(now));
if filewriting
    fid = fopen(filename,'w');
end

if filewriting
    fprintf(fid,'Method:%10s \t dictType:%s \r\n',...
        model_params.method,model_params.dictionaryType);
end

fprintf(    'Img\tSigma\tIter\tRMSE\tCard\tORMSE\tPSNR\tSSIM\n');
if filewriting
    fprintf(fid,'Img\tSigma\tIter\tRMSE\tCard\tORMSE\tPSNR\tSSIM\r\n');
end

sigma_e = 1;
model_params.sigma_e = sigma_e;
OutputDir = Output_dir;
model_params.output = OutputDir;
if exist(OutputDir,'dir') == 0
    mkdir(OutputDir);
end

for j = 1:img_num
    [p, n, x] = fileparts(img_dir(j).name);
    model_params.imgname = n;
    disp(model_params);
    
    im = double(imread(fullfile('TestImages', img_dir(j).name)));
    [h,w] = size(im);
    h = h - mod(h,model_params.scale);
    w = w - mod(w,model_params.scale);
    im = im(1:h,1:w);
    filename = fullfile(OutputDir, [model_params.imgname, '[Orig].png']);
    imwrite(uint8(im),filename);
    
    lr = imresize(im,1/model_params.scale,'bicubic');
    randn('state',0);
    noiseImg = double(lr) + sigma_e*randn(size(lr));
    filename = fullfile(OutputDir, [model_params.imgname, '[LowRes].png']);
    imwrite(double2im(noiseImg),filename);
    mid = imresize(noiseImg,model_params.scale,'bicubic');
    
    load('conf_pca_1024.mat');
    model_params.Dl = conf.dict_lores;
    model_params.Dh = conf.dict_hires;
    model_params.conf = conf;
    clear conf;
    
    I_casd = mexCASD_SR(double(im),double(mid),sigma_e,model_params);
    
    filename = fullfile(OutputDir, [model_params.imgname, '[CASD].png']);
    imwrite(double2im(I_casd),filename);
    
end
if filewriting
    fclose(fid);
end
end
