function [Q] = CalcQos(Orig_blks, Estimate_blks, Estimate_Coefs, OrigImg, RecImg, Iter)
if nargin < 6
    Iter = 0;
end
dPatch = Estimate_blks;
SubX = Orig_blks;
X_OMP = Estimate_Coefs;

Diff = (dPatch - SubX).^2;
rmse = sqrt(sum(Diff,1)/size(SubX,1));
rmse1 = mean(rmse);
rmse2 = norm((dPatch - SubX),'fro')/sqrt(numel(SubX));

[n,N] = size(SubX);
K_OMP = zeros(1,N);
for i=1:N
    K_OMP(i)=length(find(X_OMP(:,i)~=0));
end
card = mean(K_OMP);  

Q.iter = Iter;
Q.rmse_per_patch = rmse1;
Q.rmse_per_pixel = rmse2;
Q.card = card;

OrigImg = double(OrigImg);
RecImg = double(RecImg);
Q.overlapRMSE = sqrt(MeanSquareError(OrigImg,RecImg));
Q.psnr = PeakSignaltoNoiseRatio(OrigImg,RecImg);
Q.ssim = SSIM(OrigImg,RecImg);

end